home *** CD-ROM | disk | FTP | other *** search
/ Chip 2007 January, February, March & April / Chip-Cover-CD-2007-02.iso / boot / i386 / rescue / usr / bin / gzexe < prev    next >
Text File  |  2006-11-29  |  5KB  |  180 lines

  1. #!/bin/sh
  2. # gzexe: compressor for Unix executables.
  3. # Use this only for binaries that you do not use frequently.
  4. #
  5. # The compressed version is a shell script which decompresses itself after
  6. # skipping $skip lines of shell commands.  We try invoking the compressed
  7. # executable with the original name (for programs looking at their name).
  8. # We also try to retain the original file permissions on the compressed file.
  9. # For safety reasons, gzexe will not create setuid or setgid shell scripts.
  10.  
  11. # WARNING: the first line of this file must be either : or #!/bin/sh
  12. # The : is required for some old versions of csh.
  13. # On Ultrix, /bin/sh is too buggy, change the first line to: #!/bin/sh5
  14.  
  15.  
  16. # Copyright (C) 1998, 2002 Free Software Foundation
  17. # Copyright (C) 1993 Jean-loup Gailly
  18.  
  19. # This program is free software; you can redistribute it and/or modify
  20. # it under the terms of the GNU General Public License as published by
  21. # the Free Software Foundation; either version 2, or (at your option)
  22. # any later version.
  23.  
  24. # This program is distributed in the hope that it will be useful,
  25. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  26. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  27. # GNU General Public License for more details.
  28.  
  29. # You should have received a copy of the GNU General Public License
  30. # along with this program; if not, write to the Free Software
  31. # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  32. # 02111-1307, USA.
  33.  
  34.  
  35. PATH="/usr/bin:$PATH"
  36. x=`basename $0`
  37. if test $# = 0; then
  38.   echo compress executables. original file foo is renamed to foo~
  39.   echo usage: ${x} [-d] files...
  40.   echo   "   -d  decompress the executables"
  41.   exit 1
  42. fi
  43.  
  44. tmp=`mktemp /tmp/gz.XXXXXX` || {
  45.        echo 'cannot create temporary file' >&2
  46.        exit 1
  47. }
  48. trap "rm -f $tmp; exit 1" 1 2 3 5 10 13 15
  49.  
  50. decomp=0
  51. res=0
  52. test "$x" = "ungzexe" && decomp=1
  53. if test "x$1" = "x-d"; then
  54.   decomp=1
  55.   shift
  56. fi
  57.  
  58. echo hi > zfoo1$$
  59. echo hi > zfoo2$$
  60. if test -z "`(${CPMOD-cpmod} zfoo1$$ zfoo2$$) 2>&1`"; then
  61.   cpmod=${CPMOD-cpmod}
  62. fi
  63. rm -f zfoo[12]$$
  64.  
  65. tail=""
  66. IFS="${IFS=     }"; saveifs="$IFS"; IFS="${IFS}:"
  67. for dir in $PATH; do
  68.   test -z "$dir" && dir=.
  69.   if test -f $dir/tail; then
  70.     tail="$dir/tail"
  71.     break
  72.   fi
  73. done
  74. IFS="$saveifs"
  75. if test -z "$tail"; then
  76.   echo cannot find tail
  77.   exit 1
  78. fi
  79. case `echo foo | $tail -n +1 2>/dev/null` in
  80. foo) tail="$tail -n";;
  81. esac
  82.  
  83. for i do
  84.   if test ! -f "$i" ; then
  85.     echo ${x}: $i not a file
  86.     res=1
  87.     continue
  88.   fi
  89.   if test $decomp -eq 0; then
  90.     if sed -e 1d -e 2q "$i" | grep "^skip=[0-9]*$" >/dev/null; then
  91.       echo "${x}: $i is already gzexe'd"
  92.       continue
  93.     fi
  94.   fi
  95.   if ls -l "$i" | grep '^...[sS]' > /dev/null; then
  96.     echo "${x}: $i has setuid permission, unchanged"
  97.     continue
  98.   fi
  99.   if ls -l "$i" | grep '^......[sS]' > /dev/null; then
  100.     echo "${x}: $i has setgid permission, unchanged"
  101.     continue
  102.   fi
  103.   case "`basename $i`" in
  104.   gzip | tail | sed | chmod | ln | sleep | rm)
  105.     echo "${x}: $i would depend on itself"; continue ;;
  106.   esac
  107.   if test -z "$cpmod"; then
  108.     cp -p "$i" $tmp 2>/dev/null || cp "$i" $tmp
  109.     if test -w $tmp 2>/dev/null; then
  110.       writable=1
  111.     else
  112.       writable=0
  113.       chmod u+w $tmp 2>/dev/null
  114.     fi
  115.   fi
  116.   if test $decomp -eq 0; then
  117.     sed 1q $0 > $tmp
  118.     sed "s|^if tail|if $tail|" >> $tmp <<'EOF'
  119. skip=20
  120. set -C
  121. umask=`umask`
  122. umask 77
  123. xdir=`mktemp -d /tmp/gz.XXXXXX` || {
  124.     echo 'cannot create tmpdir' >&2
  125.     exit 1
  126. }
  127. trap "rm -rf $xdir; exit 1" 1 2 3 5 10 13 15
  128. trap "rm -rf $xdir" 0
  129. prog="`echo $0 | sed 's|^.*/||'`"
  130. if tail +$skip $0 | gzip -cd > $xdir/$prog; then
  131.   umask $umask
  132.   /bin/chmod 700 $xdir/$prog
  133.   $xdir/$prog "$@"; res=$?
  134. else
  135.   echo Cannot decompress $0; exit 1
  136. fi; exit $res
  137. EOF
  138.     gzip -cv9 "$i" >> $tmp || {
  139.       /bin/rm -f $tmp
  140.       echo ${x}: compression not possible for $i, file unchanged.
  141.       res=1
  142.       continue
  143.     }
  144.  
  145.   else
  146.     # decompression
  147.     skip=20
  148.     if sed -e 1d -e 2q "$i" | grep "^skip=[0-9][0-9]*$" >/dev/null; then
  149.       eval `sed -e 1d -e 2q "$i"`
  150.     fi
  151.     if tail +$skip "$i" | gzip -cd > $tmp; then
  152.       :
  153.     else
  154.       echo ${x}: $i probably not in gzexe format, file unchanged.
  155.       res=1
  156.       continue
  157.     fi
  158.   fi
  159.   rm -f "$i~"
  160.   mv "$i" "$i~" || {
  161.     echo ${x}: cannot backup $i as $i~
  162.     rm -f $tmp
  163.     res=1
  164.     continue
  165.   }
  166.   mv $tmp "$i" || cp -p $tmp "$i" 2>/dev/null || cp $tmp "$i" || {
  167.     echo ${x}: cannot create $i
  168.     rm -f $tmp
  169.     res=1
  170.     continue
  171.   }
  172.   rm -f $tmp
  173.   if test -n "$cpmod"; then
  174.     $cpmod "$i~" "$i" 2>/dev/null
  175.   elif test $writable -eq 0; then
  176.     chmod u-w $i 2>/dev/null
  177.   fi
  178. done
  179. exit $res
  180.